#include <resolv.h>
#include <string.h>
#include "nsu.h"

static char *nstypestr[] = {
	[ns_t_a]        = "a",
	[ns_t_ns]       = "ns",
	[ns_t_md]       = "md",
	[ns_t_mf]       = "mf",
	[ns_t_cname]    = "cname",
	[ns_t_soa]      = "soa",
	[ns_t_mb]       = "mb",
	[ns_t_mg]       = "mg",
	[ns_t_mr]       = "mr",
	[ns_t_null]     = "null",
	[ns_t_wks]      = "wks",
	[ns_t_ptr]      = "ptr",
	[ns_t_hinfo]    = "hinfo",
	[ns_t_minfo]    = "minfo",
	[ns_t_mx]       = "mx",
	[ns_t_txt]      = "txt",
	[ns_t_rp]       = "rp",
	[ns_t_afsdb]    = "afsdb",
	[ns_t_x25]      = "x25",
	[ns_t_isdn]     = "isdn",
	[ns_t_rt]       = "rt",
	[ns_t_nsap]     = "nsap",
	[ns_t_sig]      = "sig",
	[ns_t_key]      = "key",
	[ns_t_px]       = "px",
	[ns_t_aaaa]     = "aaaa",
	[ns_t_loc]      = "loc",
	[ns_t_nxt]      = "nxt",
	[ns_t_eid]      = "eid",
	[ns_t_nimloc]   = "nimloc",
	[ns_t_srv]      = "srv",
	[ns_t_atma]     = "atma",
	[ns_t_naptr]    = "naptr",
	[ns_t_kx]       = "kx",
	[ns_t_cert]     = "cert",
	[ns_t_dname]    = "dname",
	[ns_t_sink]     = "sink",
	[ns_t_opt]      = "opt",
	[ns_t_apl]      = "apl",
	[ns_t_tkey]     = "tkey",
	[ns_t_tsig]     = "tsig"
};

int
nsu_str_to_type(char const *str)
{
	int i;
	for (i = 0; i < sizeof(nstypestr)/sizeof(nstypestr[0]); i++)
		if (nstypestr[i] && strcasecmp(nstypestr[i], str) == 0)
			return i;
	
	return ns_t_invalid;
}

char const *
nsu_type_to_str(int type)
{
	if (type < sizeof(nstypestr)/sizeof(nstypestr[0]))
		return nstypestr[type];
	return NULL;
}
